Index: kernel/arch/mips32/src/mm/tlb.c
===================================================================
--- kernel/arch/mips32/src/mm/tlb.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/mips32/src/mm/tlb.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -48,5 +48,9 @@
 #include <symtab.h>
 
-static pte_t *find_mapping_and_check(uintptr_t, int, istate_t *);
+static void tlb_refill_fail(istate_t *);
+static void tlb_invalid_fail(istate_t *);
+static void tlb_modified_fail(istate_t *);
+
+static pte_t *find_mapping_and_check(uintptr_t, int, istate_t *, int *);
 
 /** Initialize TLB.
@@ -88,33 +92,54 @@
 	uintptr_t badvaddr;
 	pte_t *pte;
+	int pfrc;
 	
 	badvaddr = cp0_badvaddr_read();
 	asid = AS->asid;
 	
-	pte = find_mapping_and_check(badvaddr, PF_ACCESS_READ, istate);
-	if (pte) {
-		/*
-		 * Record access to PTE.
-		 */
-		pte->a = 1;
-
-		tlb_prepare_entry_hi(&hi, asid, badvaddr);
-		tlb_prepare_entry_lo(&lo, pte->g, pte->p, pte->d,
-		    pte->cacheable, pte->pfn);
-
-		/*
-		 * New entry is to be inserted into TLB
-		 */
-		cp0_entry_hi_write(hi.value);
-		if ((badvaddr / PAGE_SIZE) % 2 == 0) {
-			cp0_entry_lo0_write(lo.value);
-			cp0_entry_lo1_write(0);
-		} else {
-			cp0_entry_lo0_write(0);
-			cp0_entry_lo1_write(lo.value);
+	pte = find_mapping_and_check(badvaddr, PF_ACCESS_READ, istate, &pfrc);
+	if (!pte) {
+		switch (pfrc) {
+		case AS_PF_FAULT:
+			goto fail;
+			break;
+		case AS_PF_DEFER:
+			/*
+			 * The page fault came during copy_from_uspace()
+			 * or copy_to_uspace().
+			 */
+			return;
+		default:
+			panic("Unexpected pfrc (%d).", pfrc);
 		}
-		cp0_pagemask_write(TLB_PAGE_MASK_16K);
-		tlbwr();
-	}
+	}
+
+	/*
+	 * Record access to PTE.
+	 */
+	pte->a = 1;
+
+	tlb_prepare_entry_hi(&hi, asid, badvaddr);
+	tlb_prepare_entry_lo(&lo, pte->g, pte->p, pte->d, pte->cacheable,
+	    pte->pfn);
+
+	/*
+	 * New entry is to be inserted into TLB
+	 */
+	cp0_entry_hi_write(hi.value);
+	if ((badvaddr / PAGE_SIZE) % 2 == 0) {
+		cp0_entry_lo0_write(lo.value);
+		cp0_entry_lo1_write(0);
+	}
+	else {
+		cp0_entry_lo0_write(0);
+		cp0_entry_lo1_write(lo.value);
+	}
+	cp0_pagemask_write(TLB_PAGE_MASK_16K);
+	tlbwr();
+
+	return;
+	
+fail:
+	tlb_refill_fail(istate);
 }
 
@@ -130,4 +155,5 @@
 	entry_hi_t hi;
 	pte_t *pte;
+	int pfrc;
 
 	badvaddr = cp0_badvaddr_read();
@@ -142,31 +168,56 @@
 	index.value = cp0_index_read();
 
-	ASSERT(!index.p);
-
-	pte = find_mapping_and_check(badvaddr, PF_ACCESS_READ, istate);
-	if (pte) {
-		/*
-		 * Read the faulting TLB entry.
-		 */
-		tlbr();
-
-		/*
-		 * Record access to PTE.
-		 */
-		pte->a = 1;
-
-		tlb_prepare_entry_lo(&lo, pte->g, pte->p, pte->d,
-		    pte->cacheable, pte->pfn);
-
-		/*
-		 * The entry is to be updated in TLB.
-		 */
-		if ((badvaddr / PAGE_SIZE) % 2 == 0)
-			cp0_entry_lo0_write(lo.value);
-		else
-			cp0_entry_lo1_write(lo.value);
-		cp0_pagemask_write(TLB_PAGE_MASK_16K);
-		tlbwi();
-	}
+	/*
+	 * Fail if the entry is not in TLB.
+	 */
+	if (index.p) {
+		printf("TLB entry not found.\n");
+		goto fail;
+	}
+
+	pte = find_mapping_and_check(badvaddr, PF_ACCESS_READ, istate, &pfrc);
+	if (!pte) {
+		switch (pfrc) {
+		case AS_PF_FAULT:
+			goto fail;
+			break;
+		case AS_PF_DEFER:
+			/*
+			 * The page fault came during copy_from_uspace()
+			 * or copy_to_uspace().
+			 */
+			return;
+		default:
+			panic("Unexpected pfrc (%d).", pfrc);
+		}
+	}
+
+	/*
+	 * Read the faulting TLB entry.
+	 */
+	tlbr();
+
+	/*
+	 * Record access to PTE.
+	 */
+	pte->a = 1;
+
+	tlb_prepare_entry_lo(&lo, pte->g, pte->p, pte->d, pte->cacheable,
+	    pte->pfn);
+
+	/*
+	 * The entry is to be updated in TLB.
+	 */
+	if ((badvaddr / PAGE_SIZE) % 2 == 0)
+		cp0_entry_lo0_write(lo.value);
+	else
+		cp0_entry_lo1_write(lo.value);
+	cp0_pagemask_write(TLB_PAGE_MASK_16K);
+	tlbwi();
+
+	return;
+	
+fail:
+	tlb_invalid_fail(istate);
 }
 
@@ -182,4 +233,5 @@
 	entry_hi_t hi;
 	pte_t *pte;
+	int pfrc;
 
 	badvaddr = cp0_badvaddr_read();
@@ -197,32 +249,82 @@
 	 * Fail if the entry is not in TLB.
 	 */
-	ASSERT(!index.p);
-
-	pte = find_mapping_and_check(badvaddr, PF_ACCESS_WRITE, istate);
-	if (pte) {
-		/*
-		 * Read the faulting TLB entry.
-		 */
-		tlbr();
-
-		/*
-		 * Record access and write to PTE.
-		 */
-		pte->a = 1;
-		pte->d = 1;
-
-		tlb_prepare_entry_lo(&lo, pte->g, pte->p, pte->w,
-		    pte->cacheable, pte->pfn);
-
-		/*
-		 * The entry is to be updated in TLB.
-		 */
-		if ((badvaddr / PAGE_SIZE) % 2 == 0)
-			cp0_entry_lo0_write(lo.value);
-		else
-			cp0_entry_lo1_write(lo.value);
-		cp0_pagemask_write(TLB_PAGE_MASK_16K);
-		tlbwi();
-	}
+	if (index.p) {
+		printf("TLB entry not found.\n");
+		goto fail;
+	}
+
+	pte = find_mapping_and_check(badvaddr, PF_ACCESS_WRITE, istate, &pfrc);
+	if (!pte) {
+		switch (pfrc) {
+		case AS_PF_FAULT:
+			goto fail;
+			break;
+		case AS_PF_DEFER:
+			/*
+			 * The page fault came during copy_from_uspace()
+			 * or copy_to_uspace().
+			 */
+			return;
+		default:
+			panic("Unexpected pfrc (%d).", pfrc);
+		}
+	}
+
+	/*
+	 * Read the faulting TLB entry.
+	 */
+	tlbr();
+
+	/*
+	 * Record access and write to PTE.
+	 */
+	pte->a = 1;
+	pte->d = 1;
+
+	tlb_prepare_entry_lo(&lo, pte->g, pte->p, pte->w, pte->cacheable,
+	    pte->pfn);
+
+	/*
+	 * The entry is to be updated in TLB.
+	 */
+	if ((badvaddr / PAGE_SIZE) % 2 == 0)
+		cp0_entry_lo0_write(lo.value);
+	else
+		cp0_entry_lo1_write(lo.value);
+	cp0_pagemask_write(TLB_PAGE_MASK_16K);
+	tlbwi();
+
+	return;
+	
+fail:
+	tlb_modified_fail(istate);
+}
+
+void tlb_refill_fail(istate_t *istate)
+{
+	uintptr_t va = cp0_badvaddr_read();
+	
+	fault_if_from_uspace(istate, "TLB Refill Exception on %p.",
+	    (void *) va);
+	panic_memtrap(istate, PF_ACCESS_UNKNOWN, va, "TLB Refill Exception.");
+}
+
+
+void tlb_invalid_fail(istate_t *istate)
+{
+	uintptr_t va = cp0_badvaddr_read();
+	
+	fault_if_from_uspace(istate, "TLB Invalid Exception on %p.",
+	    (void *) va);
+	panic_memtrap(istate, PF_ACCESS_UNKNOWN, va, "TLB Invalid Exception.");
+}
+
+void tlb_modified_fail(istate_t *istate)
+{
+	uintptr_t va = cp0_badvaddr_read();
+	
+	fault_if_from_uspace(istate, "TLB Modified Exception on %p.",
+	    (void *) va);
+	panic_memtrap(istate, PF_ACCESS_WRITE, va, "TLB Modified Exception.");
 }
 
@@ -232,8 +334,12 @@
  * @param access	Access mode that caused the fault.
  * @param istate	Pointer to interrupted state.
+ * @param pfrc		Pointer to variable where as_page_fault() return code
+ * 			will be stored.
  *
  * @return		PTE on success, NULL otherwise.
  */
-pte_t *find_mapping_and_check(uintptr_t badvaddr, int access, istate_t *istate)
+pte_t *
+find_mapping_and_check(uintptr_t badvaddr, int access, istate_t *istate,
+    int *pfrc)
 {
 	entry_hi_t hi;
@@ -242,5 +348,11 @@
 	hi.value = cp0_entry_hi_read();
 
-	ASSERT(hi.asid == AS->asid);
+	/*
+	 * Handler cannot succeed if the ASIDs don't match.
+	 */
+	if (hi.asid != AS->asid) {
+		printf("EntryHi.asid=%d, AS->asid=%d\n", hi.asid, AS->asid);
+		return NULL;
+	}
 
 	/*
@@ -254,18 +366,32 @@
 		 */
 		return pte;
-	}
-
-	/*
-	 * Mapping not found in page tables.
-	 * Resort to higher-level page fault handler.
-	 */
-	if (as_page_fault(badvaddr, access, istate) == AS_PF_OK) {
-		pte = page_mapping_find(AS, badvaddr, true);
-		ASSERT(pte && pte->p);
-		ASSERT(pte->w || access != PF_ACCESS_WRITE);
-		return pte;
-	}
-
-	return NULL;
+	} else {
+		int rc;
+		
+		/*
+		 * Mapping not found in page tables.
+		 * Resort to higher-level page fault handler.
+		 */
+		switch (rc = as_page_fault(badvaddr, access, istate)) {
+		case AS_PF_OK:
+			/*
+			 * The higher-level page fault handler succeeded,
+			 * The mapping ought to be in place.
+			 */
+			pte = page_mapping_find(AS, badvaddr, true);
+			ASSERT(pte && pte->p);
+			ASSERT(pte->w || access != PF_ACCESS_WRITE);
+			return pte;
+		case AS_PF_DEFER:
+			*pfrc = AS_PF_DEFER;
+			return NULL;
+		case AS_PF_FAULT:
+			*pfrc = AS_PF_FAULT;
+			return NULL;
+		default:
+			panic("Unexpected rc (%d).", rc);
+		}
+		
+	}
 }
 
Index: kernel/arch/mips64/src/mips64.c
===================================================================
--- kernel/arch/mips64/src/mips64.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/mips64/src/mips64.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -205,5 +205,5 @@
 {
 	supervisor_sp =
-	    (uintptr_t) &THREAD->kstack[STACK_SIZE];
+	    (uintptr_t) &THREAD->kstack[STACK_SIZE - SP_DELTA];
 }
 
Index: kernel/arch/mips64/src/mm/tlb.c
===================================================================
--- kernel/arch/mips64/src/mm/tlb.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/mips64/src/mm/tlb.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -79,4 +79,6 @@
  * @param access   Access mode that caused the fault.
  * @param istate   Pointer to interrupted state.
+ * @param pfrc     Pointer to variable where as_page_fault()
+ *                 return code will be stored.
  *
  * @return PTE on success, NULL otherwise.
@@ -84,10 +86,16 @@
  */
 static pte_t *find_mapping_and_check(uintptr_t badvaddr, int access,
-    istate_t *istate)
+    istate_t *istate, int *pfrc)
 {
 	entry_hi_t hi;
 	hi.value = cp0_entry_hi_read();
 	
-	ASSERT(hi.asid == AS->asid);
+	/*
+	 * Handler cannot succeed if the ASIDs don't match.
+	 */
+	if (hi.asid != AS->asid) {
+		printf("EntryHi.asid=%d, AS->asid=%d\n", hi.asid, AS->asid);
+		return NULL;
+	}
 	
 	/*
@@ -101,23 +109,32 @@
 		 */
 		return pte;
-	}
-
-	/*
-	 * Mapping not found in page tables.
-	 * Resort to higher-level page fault handler.
-	 */
-	if (as_page_fault(badvaddr, access, istate) == AS_PF_OK) {
+	} else {
+		int rc;
+		
 		/*
-		 * The higher-level page fault handler succeeded,
-		 * The mapping ought to be in place.
+		 * Mapping not found in page tables.
+		 * Resort to higher-level page fault handler.
 		 */
-		pte = page_mapping_find(AS, badvaddr, true);
-		ASSERT(pte);
-		ASSERT(pte->p);
-		ASSERT((pte->w) || (access != PF_ACCESS_WRITE));
-		return pte;
-	}
-
-	return NULL;
+		switch (rc = as_page_fault(badvaddr, access, istate)) {
+		case AS_PF_OK:
+			/*
+			 * The higher-level page fault handler succeeded,
+			 * The mapping ought to be in place.
+			 */
+			pte = page_mapping_find(AS, badvaddr, true);
+			ASSERT(pte);
+			ASSERT(pte->p);
+			ASSERT((pte->w) || (access != PF_ACCESS_WRITE));
+			return pte;
+		case AS_PF_DEFER:
+			*pfrc = AS_PF_DEFER;
+			return NULL;
+		case AS_PF_FAULT:
+			*pfrc = AS_PF_FAULT;
+			return NULL;
+		default:
+			panic("Unexpected return code (%d).", rc);
+		}
+	}
 }
 
@@ -139,4 +156,31 @@
 }
 
+static void tlb_refill_fail(istate_t *istate)
+{
+	uintptr_t va = cp0_badvaddr_read();
+	
+	fault_if_from_uspace(istate, "TLB Refill Exception on %p.",
+	    (void *) va);
+	panic_memtrap(istate, PF_ACCESS_UNKNOWN, va, "TLB Refill Exception.");
+}
+
+static void tlb_invalid_fail(istate_t *istate)
+{
+	uintptr_t va = cp0_badvaddr_read();
+	
+	fault_if_from_uspace(istate, "TLB Invalid Exception on %p.",
+	    (void *) va);
+	panic_memtrap(istate, PF_ACCESS_UNKNOWN, va, "TLB Invalid Exception.");
+}
+
+static void tlb_modified_fail(istate_t *istate)
+{
+	uintptr_t va = cp0_badvaddr_read();
+	
+	fault_if_from_uspace(istate, "TLB Modified Exception on %p.",
+	    (void *) va);
+	panic_memtrap(istate, PF_ACCESS_WRITE, va, "TLB Modified Exception.");
+}
+
 /** Process TLB Refill Exception.
  *
@@ -152,34 +196,55 @@
 	mutex_unlock(&AS->lock);
 	
-	pte_t *pte = find_mapping_and_check(badvaddr, PF_ACCESS_READ, istate);
-	if (pte) {
-		/*
-		 * Record access to PTE.
-		 */
-		pte->a = 1;
-	
-		entry_lo_t lo;
-		entry_hi_t hi;
-	
-		tlb_prepare_entry_hi(&hi, asid, badvaddr);
-		tlb_prepare_entry_lo(&lo, pte->g, pte->p, pte->d, pte->c,
-		    pte->frame);
-	
-		/*
-		 * New entry is to be inserted into TLB
-		 */
-		cp0_entry_hi_write(hi.value);
-	
-		if ((badvaddr / PAGE_SIZE) % 2 == 0) {
-			cp0_entry_lo0_write(lo.value);
-			cp0_entry_lo1_write(0);
-		} else {
-			cp0_entry_lo0_write(0);
-			cp0_entry_lo1_write(lo.value);
+	int pfrc;
+	pte_t *pte = find_mapping_and_check(badvaddr, PF_ACCESS_READ,
+	    istate, &pfrc);
+	if (!pte) {
+		switch (pfrc) {
+		case AS_PF_FAULT:
+			goto fail;
+			break;
+		case AS_PF_DEFER:
+			/*
+			 * The page fault came during copy_from_uspace()
+			 * or copy_to_uspace().
+			 */
+			return;
+		default:
+			panic("Unexpected pfrc (%d).", pfrc);
 		}
-	
-		cp0_pagemask_write(TLB_PAGE_MASK_16K);
-		tlbwr();
-	}
+	}
+	
+	/*
+	 * Record access to PTE.
+	 */
+	pte->a = 1;
+	
+	entry_lo_t lo;
+	entry_hi_t hi;
+	
+	tlb_prepare_entry_hi(&hi, asid, badvaddr);
+	tlb_prepare_entry_lo(&lo, pte->g, pte->p, pte->d, pte->c,
+	    pte->frame);
+	
+	/*
+	 * New entry is to be inserted into TLB
+	 */
+	cp0_entry_hi_write(hi.value);
+	
+	if ((badvaddr / PAGE_SIZE) % 2 == 0) {
+		cp0_entry_lo0_write(lo.value);
+		cp0_entry_lo1_write(0);
+	} else {
+		cp0_entry_lo0_write(0);
+		cp0_entry_lo1_write(lo.value);
+	}
+	
+	cp0_pagemask_write(TLB_PAGE_MASK_16K);
+	tlbwr();
+	
+	return;
+	
+fail:
+	tlb_refill_fail(istate);
 }
 
@@ -206,34 +271,60 @@
 	index.value = cp0_index_read();
 	
-	ASSERT(!index.p);
-	
-	pte_t *pte = find_mapping_and_check(badvaddr, PF_ACCESS_READ, istate);
-	if (pte) {
-		/*
-		 * Read the faulting TLB entry.
-		 */
-		tlbr();
-	
-		/*
-		 * Record access to PTE.
-		 */
-		pte->a = 1;
-
-		entry_lo_t lo;
-		tlb_prepare_entry_lo(&lo, pte->g, pte->p, pte->d, pte->c,
-		    pte->frame);
-	
-		/*
-		 * The entry is to be updated in TLB.
-		 */
-		if ((badvaddr / PAGE_SIZE) % 2 == 0)
-			cp0_entry_lo0_write(lo.value);
-		else
-			cp0_entry_lo1_write(lo.value);
-	
-		cp0_pagemask_write(TLB_PAGE_MASK_16K);
-		tlbwi();
-	}
-	
+	/*
+	 * Fail if the entry is not in TLB.
+	 */
+	if (index.p) {
+		printf("TLB entry not found.\n");
+		goto fail;
+	}
+	
+	int pfrc;
+	pte_t *pte = find_mapping_and_check(badvaddr, PF_ACCESS_READ,
+	    istate, &pfrc);
+	if (!pte) {
+		switch (pfrc) {
+		case AS_PF_FAULT:
+			goto fail;
+			break;
+		case AS_PF_DEFER:
+			/*
+			 * The page fault came during copy_from_uspace()
+			 * or copy_to_uspace().
+			 */
+			return;
+		default:
+			panic("Unexpected pfrc (%d).", pfrc);
+		}
+	}
+	
+	/*
+	 * Read the faulting TLB entry.
+	 */
+	tlbr();
+	
+	/*
+	 * Record access to PTE.
+	 */
+	pte->a = 1;
+	
+	entry_lo_t lo;
+	tlb_prepare_entry_lo(&lo, pte->g, pte->p, pte->d, pte->c,
+	    pte->frame);
+	
+	/*
+	 * The entry is to be updated in TLB.
+	 */
+	if ((badvaddr / PAGE_SIZE) % 2 == 0)
+		cp0_entry_lo0_write(lo.value);
+	else
+		cp0_entry_lo1_write(lo.value);
+	
+	cp0_pagemask_write(TLB_PAGE_MASK_16K);
+	tlbwi();
+	
+	return;
+	
+fail:
+	tlb_invalid_fail(istate);
 }
 
@@ -260,34 +351,61 @@
 	index.value = cp0_index_read();
 	
-	ASSERT(!index.p);
-	
-	pte_t *pte = find_mapping_and_check(badvaddr, PF_ACCESS_WRITE, istate);
-	if (pte) {
-		/*
-		 * Read the faulting TLB entry.
-		 */
-		tlbr();
-	
-		/*
-		 * Record access and write to PTE.
-		 */
-		pte->a = 1;
-		pte->d = 1;
-	
-		entry_lo_t lo;
-		tlb_prepare_entry_lo(&lo, pte->g, pte->p, pte->w, pte->c,
-		    pte->frame);
-	
-		/*
-		 * The entry is to be updated in TLB.
-		 */
-		if ((badvaddr / PAGE_SIZE) % 2 == 0)
-			cp0_entry_lo0_write(lo.value);
-		else
-			cp0_entry_lo1_write(lo.value);
-	
-		cp0_pagemask_write(TLB_PAGE_MASK_16K);
-		tlbwi();
-	}
+	/*
+	 * Fail if the entry is not in TLB.
+	 */
+	if (index.p) {
+		printf("TLB entry not found.\n");
+		goto fail;
+	}
+	
+	int pfrc;
+	pte_t *pte = find_mapping_and_check(badvaddr, PF_ACCESS_WRITE,
+	    istate, &pfrc);
+	if (!pte) {
+		switch (pfrc) {
+		case AS_PF_FAULT:
+			goto fail;
+			break;
+		case AS_PF_DEFER:
+			/*
+			 * The page fault came during copy_from_uspace()
+			 * or copy_to_uspace().
+			 */
+			return;
+		default:
+			panic("Unexpected pfrc (%d).", pfrc);
+		}
+	}
+	
+	/*
+	 * Read the faulting TLB entry.
+	 */
+	tlbr();
+	
+	/*
+	 * Record access and write to PTE.
+	 */
+	pte->a = 1;
+	pte->d = 1;
+	
+	entry_lo_t lo;
+	tlb_prepare_entry_lo(&lo, pte->g, pte->p, pte->w, pte->c,
+	    pte->frame);
+	
+	/*
+	 * The entry is to be updated in TLB.
+	 */
+	if ((badvaddr / PAGE_SIZE) % 2 == 0)
+		cp0_entry_lo0_write(lo.value);
+	else
+		cp0_entry_lo1_write(lo.value);
+	
+	cp0_pagemask_write(TLB_PAGE_MASK_16K);
+	tlbwi();
+	
+	return;
+	
+fail:
+	tlb_modified_fail(istate);
 }
 
Index: kernel/arch/ppc32/src/mm/pht.c
===================================================================
--- kernel/arch/ppc32/src/mm/pht.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/ppc32/src/mm/pht.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -49,4 +49,6 @@
  * @param access   Access mode that caused the fault.
  * @param istate   Pointer to interrupted state.
+ * @param pfrc     Pointer to variable where as_page_fault() return code
+ *                 will be stored.
  *
  * @return PTE on success, NULL otherwise.
@@ -54,5 +56,5 @@
  */
 static pte_t *find_mapping_and_check(as_t *as, uintptr_t badvaddr, int access,
-    istate_t *istate)
+    istate_t *istate, int *pfrc)
 {
 	/*
@@ -66,20 +68,38 @@
 		 */
 		return pte;
-	}
-	/*
-	 * Mapping not found in page tables.
-	 * Resort to higher-level page fault handler.
-	 */
-	if (as_page_fault(badvaddr, access, istate) == AS_PF_OK) {
+	} else {
 		/*
-		 * The higher-level page fault handler succeeded,
-		 * The mapping ought to be in place.
+		 * Mapping not found in page tables.
+		 * Resort to higher-level page fault handler.
 		 */
-		pte = page_mapping_find(as, badvaddr, true);
-		ASSERT((pte) && (pte->present));
-		return pte;
-	}
-
-	return NULL;
+		int rc = as_page_fault(badvaddr, access, istate);
+		switch (rc) {
+		case AS_PF_OK:
+			/*
+			 * The higher-level page fault handler succeeded,
+			 * The mapping ought to be in place.
+			 */
+			pte = page_mapping_find(as, badvaddr, true);
+			ASSERT((pte) && (pte->present));
+			*pfrc = 0;
+			return pte;
+		case AS_PF_DEFER:
+			*pfrc = rc;
+			return NULL;
+		case AS_PF_FAULT:
+			*pfrc = rc;
+			return NULL;
+		default:
+			panic("Unexpected rc (%d).", rc);
+		}
+	}
+}
+
+static void pht_refill_fail(uintptr_t badvaddr, istate_t *istate)
+{
+	fault_if_from_uspace(istate, "PHT Refill Exception on %p.",
+	    (void *) badvaddr);
+	panic_memtrap(istate, PF_ACCESS_UNKNOWN, badvaddr,
+	    "PHT Refill Exception.");
 }
 
@@ -182,12 +202,27 @@
 		badvaddr = istate->pc;
 	
+	int pfrc;
 	pte_t *pte = find_mapping_and_check(AS, badvaddr,
-	    PF_ACCESS_READ /* FIXME */, istate);
-	
-	if (pte) {
-		/* Record access to PTE */
-		pte->accessed = 1;
-		pht_insert(badvaddr, pte);
-	}
+	    PF_ACCESS_READ /* FIXME */, istate, &pfrc);
+	
+	if (!pte) {
+		switch (pfrc) {
+		case AS_PF_FAULT:
+			pht_refill_fail(badvaddr, istate);
+			return;
+		case AS_PF_DEFER:
+			/*
+			 * The page fault came during copy_from_uspace()
+			 * or copy_to_uspace().
+			 */
+			return;
+		default:
+			panic("Unexpected pfrc (%d).", pfrc);
+		}
+	}
+	
+	/* Record access to PTE */
+	pte->accessed = 1;
+	pht_insert(badvaddr, pte);
 }
 
Index: kernel/arch/ppc32/src/ppc32.c
===================================================================
--- kernel/arch/ppc32/src/ppc32.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/ppc32/src/ppc32.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -103,5 +103,4 @@
 }
 
-#ifdef CONFIG_FB
 static bool display_register(ofw_tree_node_t *node, void *arg)
 {
@@ -170,5 +169,4 @@
 	return true;
 }
-#endif
 
 void arch_post_mm_init(void)
Index: kernel/arch/ppc32/src/proc/scheduler.c
===================================================================
--- kernel/arch/ppc32/src/proc/scheduler.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/ppc32/src/proc/scheduler.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -55,5 +55,5 @@
 	asm volatile (
 		"mtsprg0 %[ksp]\n"
-		:: [ksp] "r" (KA2PA(&THREAD->kstack[STACK_SIZE]))
+		:: [ksp] "r" (KA2PA(&THREAD->kstack[STACK_SIZE - SP_DELTA]))
 	);
 }
Index: kernel/arch/sparc64/src/mm/sun4u/tlb.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4u/tlb.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/sparc64/src/mm/sun4u/tlb.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -58,4 +58,10 @@
 static void dtlb_pte_copy(pte_t *, size_t, bool);
 static void itlb_pte_copy(pte_t *, size_t);
+static void do_fast_instruction_access_mmu_miss_fault(istate_t *, uintptr_t,
+    const char *);
+static void do_fast_data_access_mmu_miss_fault(istate_t *, tlb_tag_access_reg_t,
+    const char *);
+static void do_fast_data_access_protection_fault(istate_t *,
+    tlb_tag_access_reg_t, const char *);
 
 const char *context_encoding[] = {
@@ -216,5 +222,9 @@
 		 * handler.
 		 */
-		as_page_fault(page_16k, PF_ACCESS_EXEC, istate);
+		if (as_page_fault(page_16k, PF_ACCESS_EXEC, istate) ==
+		    AS_PF_FAULT) {
+			do_fast_instruction_access_mmu_miss_fault(istate,
+			    istate->tpc, __func__);
+		}
 	}
 }
@@ -246,10 +256,12 @@
 		if (!tag.vpn) {
 			/* NULL access in kernel */
-			panic("NULL pointer dereference.");
+			do_fast_data_access_mmu_miss_fault(istate, tag,
+			    "Dereferencing NULL pointer.");
 		} else if (page_8k >= end_of_identity) {
 			/* Kernel non-identity. */
 			as = AS_KERNEL;
 		} else {
-			panic("Unexpected kernel page fault.");
+			do_fast_data_access_mmu_miss_fault(istate, tag,
+		    "Unexpected kernel page fault.");
 		}
 	}
@@ -271,5 +283,9 @@
 		 * handler.
 		 */
-		as_page_fault(page_16k, PF_ACCESS_READ, istate);
+		if (as_page_fault(page_16k, PF_ACCESS_READ, istate) ==
+		    AS_PF_FAULT) {
+			do_fast_data_access_mmu_miss_fault(istate, tag,
+			    __func__);
+		}
 	}
 }
@@ -316,5 +332,9 @@
 		 * handler.
 		 */		
-		as_page_fault(page_16k, PF_ACCESS_WRITE, istate);
+		if (as_page_fault(page_16k, PF_ACCESS_WRITE, istate) ==
+		    AS_PF_FAULT) {
+			do_fast_data_access_protection_fault(istate, tag,
+			    __func__);
+		}
 	}
 }
@@ -408,4 +428,33 @@
 
 #endif
+
+void do_fast_instruction_access_mmu_miss_fault(istate_t *istate,
+    uintptr_t va, const char *str)
+{
+	fault_if_from_uspace(istate, "%s, address=%p.", str, (void *) va);
+	panic_memtrap(istate, PF_ACCESS_EXEC, va, str);
+}
+
+void do_fast_data_access_mmu_miss_fault(istate_t *istate,
+    tlb_tag_access_reg_t tag, const char *str)
+{
+	uintptr_t va;
+
+	va = tag.vpn << MMU_PAGE_WIDTH;
+	fault_if_from_uspace(istate, "%s, page=%p (asid=%u).", str,
+	    (void *) va, tag.context);
+	panic_memtrap(istate, PF_ACCESS_UNKNOWN, va, str);
+}
+
+void do_fast_data_access_protection_fault(istate_t *istate,
+    tlb_tag_access_reg_t tag, const char *str)
+{
+	uintptr_t va;
+
+	va = tag.vpn << MMU_PAGE_WIDTH;
+	fault_if_from_uspace(istate, "%s, page=%p (asid=%u).", str,
+	    (void *) va, tag.context);
+	panic_memtrap(istate, PF_ACCESS_WRITE, va, str);
+}
 
 void describe_dmmu_fault(void)
Index: kernel/arch/sparc64/src/mm/sun4v/tlb.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/tlb.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/sparc64/src/mm/sun4v/tlb.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -62,4 +62,10 @@
 static void itlb_pte_copy(pte_t *);
 static void dtlb_pte_copy(pte_t *, bool);
+static void do_fast_instruction_access_mmu_miss_fault(istate_t *, uintptr_t,
+    const char *);
+static void do_fast_data_access_mmu_miss_fault(istate_t *, uint64_t,
+    const char *);
+static void do_fast_data_access_protection_fault(istate_t *,
+    uint64_t, const char *);
 
 /*
@@ -229,5 +235,8 @@
 		 * handler.
 		 */
-		as_page_fault(va, PF_ACCESS_EXEC, istate);
+		if (as_page_fault(va, PF_ACCESS_EXEC, istate) == AS_PF_FAULT) {
+			do_fast_instruction_access_mmu_miss_fault(istate,
+			    istate->tpc, __func__);
+		}
 	}
 }
@@ -255,7 +264,9 @@
 		if (va == 0) {
 			/* NULL access in kernel */
-			panic("NULL pointer dereference.");
+			do_fast_data_access_mmu_miss_fault(istate, page_and_ctx,
+			    __func__);
 		}
-		panic("Unexpected kernel page fault.");
+		do_fast_data_access_mmu_miss_fault(istate, page_and_ctx, "Unexpected "
+		    "kernel page fault.");
 	}
 
@@ -276,5 +287,8 @@
 		 * handler.
 		 */		
-		as_page_fault(va, PF_ACCESS_READ, istate);
+		if (as_page_fault(va, PF_ACCESS_READ, istate) == AS_PF_FAULT) {
+			do_fast_data_access_mmu_miss_fault(istate, page_and_ctx,
+			    __func__);
+		}
 	}
 }
@@ -315,5 +329,8 @@
 		 * handler.
 		 */		
-		as_page_fault(va, PF_ACCESS_WRITE, istate);
+		if (as_page_fault(va, PF_ACCESS_WRITE, istate) == AS_PF_FAULT) {
+			do_fast_data_access_protection_fault(istate, page_and_ctx,
+			    __func__);
+		}
 	}
 }
@@ -329,4 +346,30 @@
 }
 
+void do_fast_instruction_access_mmu_miss_fault(istate_t *istate, uintptr_t va,
+    const char *str)
+{
+	fault_if_from_uspace(istate, "%s, address=%p.", str,
+	    (void *) va);
+	panic_memtrap(istate, PF_ACCESS_EXEC, va, str);
+}
+
+void do_fast_data_access_mmu_miss_fault(istate_t *istate,
+    uint64_t page_and_ctx, const char *str)
+{
+	fault_if_from_uspace(istate, "%s, page=%p (asid=%" PRId64 ").", str,
+	    (void *) DMISS_ADDRESS(page_and_ctx), DMISS_CONTEXT(page_and_ctx));
+	panic_memtrap(istate, PF_ACCESS_UNKNOWN, DMISS_ADDRESS(page_and_ctx),
+	    str);
+}
+
+void do_fast_data_access_protection_fault(istate_t *istate,
+    uint64_t page_and_ctx, const char *str)
+{
+	fault_if_from_uspace(istate, "%s, page=%p (asid=%" PRId64 ").", str,
+	    (void *) DMISS_ADDRESS(page_and_ctx), DMISS_CONTEXT(page_and_ctx));
+	panic_memtrap(istate, PF_ACCESS_WRITE, DMISS_ADDRESS(page_and_ctx),
+	    str);
+}
+
 /**
  * Describes the exact condition which caused the last DMMU fault.
Index: kernel/arch/sparc64/src/proc/sun4u/scheduler.c
===================================================================
--- kernel/arch/sparc64/src/proc/sun4u/scheduler.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/sparc64/src/proc/sun4u/scheduler.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -52,6 +52,4 @@
 {
 	if (THREAD->uspace) {
-		uint64_t sp;
-
 		/*
 		 * Write kernel stack address to %g6 of the alternate and
@@ -65,5 +63,6 @@
 		 *   before it explicitly uses %g7.
 		 */
-		sp = (uintptr_t) THREAD->kstack + STACK_SIZE - STACK_BIAS;
+		uint64_t sp = (uintptr_t) THREAD->kstack + STACK_SIZE -
+		    (STACK_BIAS + ALIGN_UP(STACK_ITEM_SIZE, STACK_ALIGNMENT));
 		write_to_ig_g6(sp);
 		write_to_ag_g6(sp);
@@ -77,6 +76,5 @@
 	if (THREAD->uspace) {
 		/* sample the state of the userspace window buffer */
-		THREAD->arch.uspace_window_buffer =
-		    (uint8_t *) read_from_ag_g7();
+		THREAD->arch.uspace_window_buffer = (uint8_t *) read_from_ag_g7();
 	}
 }
Index: kernel/arch/sparc64/src/proc/sun4v/scheduler.c
===================================================================
--- kernel/arch/sparc64/src/proc/sun4v/scheduler.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/sparc64/src/proc/sun4v/scheduler.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -55,7 +55,6 @@
 {
 	if (THREAD->uspace) {
-		uint64_t sp;
-
-		sp = (uintptr_t) THREAD->kstack + STACK_SIZE - STACK_BIAS;
+		uint64_t sp = (uintptr_t) THREAD->kstack + STACK_SIZE -
+		    (STACK_BIAS + ALIGN_UP(STACK_ITEM_SIZE, STACK_ALIGNMENT));
 		asi_u64_write(ASI_SCRATCHPAD, SCRATCHPAD_KSTACK, sp);
 		asi_u64_write(ASI_SCRATCHPAD, SCRATCHPAD_WBUF,
Index: kernel/genarch/Makefile.inc
===================================================================
--- kernel/genarch/Makefile.inc	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/genarch/Makefile.inc	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -106,19 +106,4 @@
 endif
 
-ifeq ($(CONFIG_AM335X_UART),y)
-	GENARCH_SOURCES += \
-		genarch/src/drivers/am335x/uart.c
-endif
-
-ifeq ($(CONFIG_AM335X_TIMERS),y)
-	GENARCH_SOURCES += \
-		genarch/src/drivers/am335x/timer.c
-endif
-
-ifeq ($(CONFIG_AMDM37X_UART),y)
-	GENARCH_SOURCES += \
-		genarch/src/drivers/amdm37x/uart.c
-endif
-
 ifeq ($(CONFIG_VIA_CUDA),y)
 	GENARCH_SOURCES += \
Index: kernel/genarch/src/mm/page_ht.c
===================================================================
--- kernel/genarch/src/mm/page_ht.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/genarch/src/mm/page_ht.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -209,8 +209,4 @@
 		pte->frame = ALIGN_DOWN(frame, FRAME_SIZE);
 
-		/*
-		 * Make sure that a concurrent ht_mapping_find() will see the
-		 * new entry only after it is fully initialized.
-		 */
 		write_barrier();
 		
Index: kernel/genarch/src/mm/page_pt.c
===================================================================
--- kernel/genarch/src/mm/page_pt.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/genarch/src/mm/page_pt.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -89,9 +89,4 @@
 		    PAGE_NOT_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
 		    PAGE_WRITE);
-		/*
-		 * Make sure that a concurrent hardware page table walk or
-		 * pt_mapping_find() will see the new PTL1 only after it is
-		 * fully initialized.
-		 */
 		write_barrier();
 		SET_PTL1_PRESENT(ptl0, PTL0_INDEX(page));
@@ -108,7 +103,4 @@
 		    PAGE_NOT_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
 		    PAGE_WRITE);
-		/*
-		 * Make the new PTL2 visible only after it is fully initialized.
-		 */
 		write_barrier();
 		SET_PTL2_PRESENT(ptl1, PTL1_INDEX(page));	
@@ -125,7 +117,4 @@
 		    PAGE_NOT_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
 		    PAGE_WRITE);
-		/*
-		 * Make the new PTL3 visible only after it is fully initialized.
-		 */
 		write_barrier();
 		SET_PTL3_PRESENT(ptl2, PTL2_INDEX(page));
@@ -136,7 +125,4 @@
 	SET_FRAME_ADDRESS(ptl3, PTL3_INDEX(page), frame);
 	SET_FRAME_FLAGS(ptl3, PTL3_INDEX(page), flags | PAGE_NOT_PRESENT);
-	/*
-	 * Make the new mapping visible only after it is fully initialized.
-	 */
 	write_barrier();
 	SET_FRAME_PRESENT(ptl3, PTL3_INDEX(page));
@@ -310,7 +296,4 @@
 
 #if (PTL1_ENTRIES != 0)
-	/*
-	 * Always read ptl2 only after we are sure it is present.
-	 */
 	read_barrier();
 #endif
@@ -321,7 +304,4 @@
 
 #if (PTL2_ENTRIES != 0)
-	/*
-	 * Always read ptl3 only after we are sure it is present.
-	 */
 	read_barrier();
 #endif
Index: kernel/generic/include/config.h
===================================================================
--- kernel/generic/include/config.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/include/config.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -44,6 +44,4 @@
 #define STACK_FRAMES  TWO_FRAMES
 #define STACK_SIZE    ((1 << STACK_FRAMES) << PAGE_WIDTH)
-
-#define STACK_SIZE_USER	(1 * 1024 * 1024)
 
 #define CONFIG_INIT_TASKS        32
Index: kernel/generic/include/console/console.h
===================================================================
--- kernel/generic/include/console/console.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/include/console/console.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -67,5 +67,5 @@
 extern wchar_t getc(indev_t *indev);
 extern size_t gets(indev_t *indev, char *buf, size_t buflen);
-extern sysarg_t sys_klog(int cmd, const void *buf, size_t size);
+extern sysarg_t sys_klog(int fd, const void *buf, size_t size);
 
 extern void grab_console(void);
